@echo off
rem tools: jwasm, jwlink, jfc, ms link (COFF)
cd tmp
for %%f in (..\asm\*.asm) do call :cmpbin %%f
for %%f in (..\asn\*.asn) do call :cmpmz  %%f
for %%f in (..\aso\*.aso) do call :cmperr %%f
for %%f in (..\asz\*.asz) do call :lnkomf %%f
rem call :safeseh
call :coff
rem call :coffdbg
rem call :ifdef
cd ..
exit

:cmpbin
..\jwasm -q -bin %1
..\jfc %~n1.BIN ..\exp\%~n1.EXP
goto end

:cmpmz
..\jwasm -q -mz %1
..\jfc %~n1.EXE ..\exp\%~n1.EXP
goto end

:cmperr
..\jwasm -q -omf %1 >NUL
..\jfc %~n1.ERR ..\exp\%~n1.EXP
goto end

:lnkomf
..\jwasm -q -omf %1
if errorlevel 1 goto end
..\jwlink op q,nofar format dos LIBPath ..\lib file %~n1.OBJ
..\jfc %~n1.EXE ..\exp\%~n1.EXP
goto end

:safeseh
..\jwasm -q -coff -safeseh ..\asc\SAFESEH.ASC
if errorlevel 1 goto end
..\link /nologo /SAFESEH SAFESEH.OBJ ..\lib\SAFESEH.LIB
..\jfc -pe SAFESEH.EXE ..\exp\SAFESEH.EXP
goto end

:coff
rem weak externals
..\jwasm -q -coff ..\asc\EXTERN4.ASC
if errorlevel 1 goto end
rem ..\link /nologo /subsystem:console EXTERN4.OBJ
rem ..\jfc -pe EXTERN4.EXE ..\exp\EXTERN4.EXP

rem ALIAS segment attribute
..\jwasm -q -coff ..\asc\SEGALIAS.ASC
if errorlevel 1 goto end
..\jfc -co SEGALIAS.OBJ ..\exp\SEGALIAS.EXP

rem 64-bit dll
rem ..\jwasm -q -coff ..\asc\DLL64.ASC
rem if errorlevel 1 goto end
rem ..\jfc -co DLL64.OBJ ..\exp\DLL64.EXP

..\jwasm -q -coff ..\asc\SEH64.ASC
if errorlevel 1 goto end
..\jfc -co SEH64.OBJ ..\exp\SEH64.EXP

..\jwasm -q -win64 ..\asc\MOV643.ASC
if errorlevel 1 goto end
..\jfc -co MOV643.OBJ ..\exp\MOV643.EXP

..\jwasm -q -win64 ..\asc\PROC641.ASC
if errorlevel 1 goto end
..\jfc -co PROC641.OBJ ..\exp\PROC641.EXP

rem option dllimport
..\jwasm -q -coff -Fd ..\asc\DLLIMP.ASC
goto end
if errorlevel 1 goto end
..\jwlink2 format win pe f DLLIMP.OBJ op q,noreloc
..\jfc -pe DLLIMP.EXE ..\exp\DLLIMP.EXP
goto end

:coffdbg
..\jwasm -q -Zi -coff ..\asc\DBGCV.ASC
if errorlevel 1 goto end
..\jfc -co DBGCV.OBJ ..\exp\DBGCV.EXP
goto end

:ifdef
..\jwasmr -q -zlc -zld ..\asc\ISDEF.ASC
if errorlevel 1 goto end
..\jfc ISDEF.OBJ ..\exp\ISDEF.EXP
goto end

:end
